<?php

namespace App\Http\Controllers\Admin;

/** Ajax Request */

use App\Unit;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;

class UnitController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath = '/admin/units';
    /** View folder */
    private $viewDirectory = 'admin.units.';

    /**
     * Display a listing of the units.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= moduleName('units', getCurrentLocale()) ?? __('units.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the units.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Unit::latest();

        if ($request->date_from) {
            $query->whereDate('units.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('units.created_at', '<=', $request->date_to);
        }

        if ($request->applicant_name) {
            $query->where('units.applicant_name', 'LIKE', '%'.$request->applicant_name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }
        $units= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('units'));
    }


    /**
     * Show the form for editing the specified unit.
     *
     * @param  Unit  $unit
     * @return View
     */
    public function edit(Unit $unit) :View
    {
//        dd($unit->toArray());
        $head = metaFields('units', 'edit', getCurrentLocale()) ?? __('units.edit');
        return view( $this->viewDirectory.'form', compact('unit', 'head') );
    }



    /**
     * Remove the specified unit from storage.
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $unit= Unit::withTrashed()->find($id);
        if ($unit) {
            if ($unit->deleted_at) {
                $unit->forceDelete();
            } else {
                $unit->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several units by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;

        if ($request->force) {
            Unit::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Unit::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified unit from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $unit= Unit::withTrashed()->find($id);
        if ($unit) {
            $unit->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);

    }

    /**
     * Restore several units by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        Unit::whereIn('id', $ids)->onlyTrashed()->restore();
        return response()->json(['message'=> __('dashboard.saveDone')]);
    }
}
